/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import PersonDto from '../model/PersonDto';

/**
* PersonController service.
* @module api/PersonControllerApi
* @version v0
*/
export default class PersonControllerApi {

    /**
    * Constructs a new PersonControllerApi. 
    * @alias module:api/PersonControllerApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the addPerson operation.
     * @callback module:api/PersonControllerApi~addPersonCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {module:model/PersonDto} personDto 
     * @param {module:api/PersonControllerApi~addPersonCallback} callback The callback function, accepting three arguments: error, data, response
     */
    addPerson(personDto, callback) {
      let postBody = personDto;
      // verify the required parameter 'personDto' is set
      if (personDto === undefined || personDto === null) {
        throw new Error("Missing the required parameter 'personDto' when calling addPerson");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = ['application/json'];
      let accepts = [];
      let returnType = null;
      return this.apiClient.callApi(
        '/api/person', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the getPerson operation.
     * @callback module:api/PersonControllerApi~getPersonCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PersonDto} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {module:api/PersonControllerApi~getPersonCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PersonDto}
     */
    getPerson(callback) {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = [];
      let accepts = ['*/*'];
      let returnType = PersonDto;
      return this.apiClient.callApi(
        '/api/person', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
